#include <iostream>
#include <functional>
#include <set>
#include <string>
#include <bitset>
#include <algorithm>

using namespace std;

const int FRAMES = 'Z' - 'A' + 1;

bool before[FRAMES][FRAMES];
char lastf;

string prepend_ch(char ch, string s) { return ch + s; }

// return all possible orderings
set<string> Order(bitset<FRAMES> ordfrm, int depth = 0)
{
    char i, j;
    set<string> res;

    if ( depth == lastf - 'A' ) {
        res.insert("");
        return res;
    }
    for ( i = 'A'; i < lastf; i++ ) if ( !ordfrm[i - 'A'] ) {
        for ( j = 'A'; j < lastf; j++ )
            if ( before[j - 'A'][i - 'A'] && !ordfrm[j - 'A'] ) break;
        if ( j == lastf ) {
            set<string> sm = Order(bitset<FRAMES>(ordfrm).set(i - 'A'), depth + 1);
            transform(sm.begin(), sm.end(), inserter(res, res.end()),
                      bind1st(ptr_fun(prepend_ch), i));
        }
    }
    return res;
}

void GenGraph(char mat[FRAMES][FRAMES], int n, int m)
{
    char ch;

    for ( int i = 0; i < FRAMES; i++ )
        for ( int j = 0; j < FRAMES; j++ ) before[i][j] = false;

    for ( ch = 'A'; ; ch++ ) {
        int r0 = n, c0 = m, r1 = 0, c1 = 0;

        for ( int i = 0; i < n; i++ )
            for ( int j = 0; j < m; j++ )
                if ( mat[i][j] == ch ) {
                    if ( r0 > i ) r0 = i;
                    if ( c0 > j ) c0 = j;
                    if ( r1 < i ) r1 = i;
                    if ( c1 < j ) c1 = j;
                }
        if ( r0 == n ) break;

        for ( int i = r0; i <= r1; i++ ) {
            if ( mat[i][c0] != ch ) before[ch - 'A'][mat[i][c0] - 'A'] = true;
            if ( mat[i][c1] != ch ) before[ch - 'A'][mat[i][c1] - 'A'] = true;
        }
        for ( int j = c0; j <= c1; j++ ) {
            if ( mat[r0][j] != ch ) before[ch - 'A'][mat[r0][j] - 'A'] = true;
            if ( mat[r1][j] != ch ) before[ch - 'A'][mat[r1][j] - 'A'] = true;
        }
    }
    lastf = ch;
}

int main()
{
    int n, m;
    static char mat[FRAMES][FRAMES];

    while ( true ) {
        cin >> n >> m;
        if ( n == 0 ) break;

        for ( int i = 0; i < n; i++ ) cin >> mat[i];

        GenGraph(mat, n, m);
        set<string> res = Order(bitset<FRAMES>());

        for ( set<string>::iterator it = res.begin(); it != res.end(); ++it )
            cout << *it << endl;
        cout << endl;
    }
}

